<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 05/06/2004 *
 * ================                             Last change: 05/06/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-maintenance.php                             *
 * -------------------------------------------------------------------- *
 * Short description : De/activate maintenance mode                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Wartungsmodus de/aktivieren                      *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!IS_ADMIN()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

if (isset($_POST['ok']))
{
	// De- or activate maintenance mode
	switch ($_CONFIG['maintenance'])
	{
	case 'Y':
		$target_mode = 'N';
		$out = ADMIN_MAINTENANCE_DEACTIVATED;
		break;

	case 'N':
		$target_mode = 'Y';
		$out = ADMIN_MAINTENANCE_ACTIVATED;
		break;
	}

	// Update config
	$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_config SET maintenance='%s' WHERE config=0 LIMIT 1",
	 array($target_mode), __FILE__, __LINE__);

	// Load template
	LOAD_TEMPLATE("admin_settings_saved", false, $out);
}
 else
{
	switch ($_CONFIG['maintenance'])
	{
	case 'Y': // Maintenance mode is active
		define('ADMIN_MAINTENANCE_MODE', ADMIN_MAINTENANCE_MODE_IS_ACTIVE);
		break;

	case 'N': // Maintenance mode is inactive
		define('ADMIN_MAINTENANCE_MODE', ADMIN_MAINTENANCE_MODE_IS_INACTIVE);
		break;
	}
	// Display form
	LOAD_TEMPLATE("admin_maintenance_form");
}
//
?>
